<html lang="en">
<head>
<title>Validate - psgml</title>
<meta http-equiv="Content-Type" content="text/html">
<meta name="description" content="psgml">
<meta name="generator" content="makeinfo 4.8">
<link title="Top" rel="start" href="index.html#Top">
<link rel="prev" href="Entity-manager.html#Entity-manager" title="Entity manager">
<link rel="next" href="SGML-declaration.html#SGML-declaration" title="SGML declaration">
<link href="http://www.gnu.org/software/texinfo/" rel="generator-home" title="Texinfo Homepage">
<meta http-equiv="Content-Style-Type" content="text/css">
<style type="text/css"><!--
  pre.display { font-family:inherit }
  pre.format  { font-family:inherit }
  pre.smalldisplay { font-family:inherit; font-size:smaller }
  pre.smallformat  { font-family:inherit; font-size:smaller }
  pre.smallexample { font-size:smaller }
  pre.smalllisp    { font-size:smaller }
  span.sc    { font-variant:small-caps }
  span.roman { font-family:serif; font-weight:normal; } 
  span.sansserif { font-family:sans-serif; font-weight:normal; } 
--></style>
</head>
<body>
<div class="node">
<p>
<a name="Validate"></a>
Next:&nbsp;<a rel="next" accesskey="n" href="SGML-declaration.html#SGML-declaration">SGML declaration</a>,
Previous:&nbsp;<a rel="previous" accesskey="p" href="Entity-manager.html#Entity-manager">Entity manager</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="index.html#Top">Top</a>
<hr>
</div>

<!-- node-name,  next,  previous,  up -->
<h2 class="chapter">5 Running an external SGML parser</h2>

<p><a name="index-C_002dc-C_002dv-19"></a><a name="index-sgml_002dvalidate-20"></a>PSGML can not validate an SGML document (see below what it can
and can't do).  If you have a validating SGML parser, like
<samp><span class="file">sgmls</span></samp>, you can run the parser on your file with the
command <kbd>C-c C-v</kbd> (<code>sgml-validate</code>).

   <p>Some variables control this function:

<div class="defun">
&mdash; User Option: <b>sgml-validate-command</b><var><a name="index-sgml_002dvalidate_002dcommand-21"></a></var><br>
<blockquote><p>The shell command to validate an SGML document.

        <p>This is a <code>format</code> control string that by default should contain two
<code>%s</code> conversion specifications: the first will be replaced by the
value of <code>sgml-declaration</code> (or the empty string, if nil); the
second will be replaced by the current buffer's file name (or the
empty string, if nil).

        <p>If <code>sgml-validate-files</code> is non-nil, the format string should contain
one <code>%s</code> conversion specification for each element of its result.

        <p>If sgml-validate-command is a list, then every element should be a
string.  The strings will be tried in order and `<samp><span class="samp">%</span></samp>'-sequences in the
string will be replaced according to the list below, if the string contains
`<samp><span class="samp">%</span></samp>'-sequences with no replacement value the next string will be tried.

          <dl>
<dt><code>%b</code><dd>means the visited file of the current buffer

          <br><dt><code>%s</code><dd>means the SGML declaration specified in the sgml-declaration variable

          <br><dt><code>%d</code><dd>means the file containing the DOCTYPE declaration, if not in the buffer
</dl>

        <p>The default value is <code>nsgmls -s %s %s</code>. 
</p></blockquote></div>

<div class="defun">
&mdash; User Option: <b>sgml-validate-files</b><var><a name="index-sgml_002dvalidate_002dfiles-22"></a></var><br>
<blockquote><p>If non-nil, a function of no arguments that returns a list of
file names.  These file names will serve as the arguments to the
<code>sgml-validate-command</code> format control string instead of
the defaults. 
</p></blockquote></div>

<div class="defun">
&mdash; User Option: <b>sgml-declaration</b><var><a name="index-sgml_002ddeclaration-23"></a></var><br>
<blockquote><p>The name of the SGML declaration file. 
</p></blockquote></div>

<div class="defun">
&mdash; User Option: <b>sgml-offer-save</b><var><a name="index-sgml_002doffer_002dsave-24"></a></var><br>
<blockquote><p>If non-nil, <kbd>C-c C-v</kbd> (<code>sgml-validate</code>) will ask about
saving modified buffers before running the validate command. 
The default value is <code>t</code>. 
</p></blockquote></div>

   <p><a name="index-C_002dc-C_002do-25"></a><a name="index-sgml_002dnext_002dtrouble_002dspot-26"></a>The built-in parser can find some markup errors.  The command <kbd>C-c
C-o</kbd> (<code>sgml-next-trouble-spot</code>) is the best way to use the built-in
parser for this.  To check the whole file go to the beginning of the
buffer and use <kbd>C-c C-o</kbd>.

   <p>Some of the markup errors not found are:

     <ul>
<li>Errors in the SGML declaration. 
<li>Errors in attribute specifications. 
<li>Omitted start-tags for empty elements. 
</ul>

<!--  -->
</body></html>

